unit uLabyrinth2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls, utmgraf, StdCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Datei1: TMenuItem;
    Labyrinthladen1: TMenuItem;
    Labyrinthspeichern1: TMenuItem;
    N1: TMenuItem;
    Ende1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Bearbeiten1: TMenuItem;
    Labyrinthzeichnen1: TMenuItem;
    MGraf1: TMGraf;
    AnfangUndEndemarkieren1: TMenuItem;
    eAx: TEdit;
    lAx: TLabel;
    eAy: TEdit;
    lAy: TLabel;
    Wegsuchen1: TMenuItem;
    lEx: TLabel;
    lEy: TLabel;
    eEx: TEdit;
    eEy: TEdit;
    lDelay: TLabel;
    eDelay: TEdit;
    procedure Ende1Click(Sender: TObject);
    procedure Labyrinthladen1Click(Sender: TObject);
    procedure Labyrinthspeichern1Click(Sender: TObject);
    procedure Labyrinthzeichnen1Click(Sender: TObject);
    procedure AnfangUndEndemarkieren1Click(Sender: TObject);
    procedure Wegsuchen1Click(Sender: TObject);
  private
    f : text;                        // Textfile
    l : array[1..15,1..15] of byte;
    ax,ay,ex,ey : byte;              // Anfangs und Endpunkt
    procedure zeigeLabyrinth;
  end;

var
  Form1  : TForm1;

implementation

{$R *.DFM}

  procedure warte(t: longint);
  var
    a: longint;
  begin
    a := Gettickcount;
    repeat
      Application.Processmessages;
    until (Gettickcount > a+t);
  end;

procedure TForm1.Ende1Click(Sender: TObject);
begin
  halt
end;

procedure TForm1.Labyrinthladen1Click(Sender: TObject);
var
  hs  : string;
  x,y : byte;
begin
  try
    if OpenDialog1.Execute then
    begin
      AssignFile(f,OpenDialog1.FileName);
      Reset(f);
      for y := 15 downto 1 do
      begin
        readln(f,hs);
        for x := 1 to 15 do
          if hs[x] < 'A' then
            l[x,y] := ord(hs[x])-48
          else
            l[x,y] := ord(hs[x])-55;
      end;
      CloseFile(f);
    end;
    ax := StrToInt(eAx.text); ay := StrToInt(eAy.text);
    ex := StrToInt(eEx.text); ey := StrToInt(eEy.text);
    zeigeLabyrinth;
  except
    ShowMessage('Fehler beim Laden eines Labyrinths!');
  end;
end;


procedure TForm1.Labyrinthspeichern1Click(Sender: TObject);
var
  hs  : string;
  x,y : byte;
begin
  try
    if SaveDialog1.Execute then
    begin
      AssignFile(f,SaveDialog1.FileName);
      Rewrite(f);
      for y := 15 downto 1 do
      begin
        hs := '';
        for x := 1 to 15 do
          if l[x,y] < 10 then
            hs := hs+char(l[x,y]+48)
          else
            hs := hs+char(l[x,y]+55);
        writeLn(f,hs)
      end;
      CloseFile(f);
    end;
  except
    ShowMessage('Fehler beim Speichern eines Labyrinths!');
  end;
end;

procedure TForm1.zeigeLabyrinth;
var
  x,y,w : byte;
begin
  MGraf1.loesche;
  // (x,y) liegt an Ecke rechts oben eines Feldes
  for x := 1 to 15 do
    for y := 1 to 15 do
      begin
        w := l[x,y];
        // Markierung
        if w > 15 then
        begin MGraf1.SetzefettenPunkt(x-0.5,y-0.5,clBlue); w := w-16; end;
        // unten
        if w mod 2 = 1 then MGraf1.Linie(x-1,y-1,x,y-1); w := w div 2;
        // rechts
        if w mod 2 = 1 then MGraf1.Linie(x,y-1,x,y);     w := w div 2;
        // oben
        if w mod 2 = 1 then MGraf1.Linie(x-1,y,x,y);     w := w div 2;
        // links
        if w mod 2 = 1 then MGraf1.Linie(x-1,y-1,x-1,y);
      end;
  // Anfangs- und Endpunkt setzen , keine Markierung!
  MGraf1.SetzefettenPunkt(ax-0.5,ay-0.5,clRed);
  MGraf1.SetzefettenPunkt(ex-0.5,ey-0.5,clGreen);
end;

procedure TForm1.Labyrinthzeichnen1Click(Sender: TObject);
begin
  zeigeLabyrinth;
end;

procedure TForm1.AnfangUndEndemarkieren1Click(Sender: TObject);
begin
  ax := StrToInt(eAx.text); ay := StrToInt(eAy.text);
  ex := StrToInt(eEx.text); ey := StrToInt(eEy.text);
  zeigeLabyrinth;
end;


procedure TForm1.Wegsuchen1Click(Sender: TObject);
var
  delay : integer;

  procedure untersuche(x,y : integer);
  begin
    if l[x,y] < 16 then
    begin
      l[x,y] := l[x,y]+16; // markieren, dh. Bit4 setzen
      zeigeLabyrinth;
      repaint; warte(delay);
      if (x = ex) and (y = ey) then
      begin
        // Lsung gefunden
        zeigeLabyrinth;
        warte(3000);
      end
      else
      begin
        // rechts
        if (l[x,y] and 2) = 0 // Bit1 nicht gesetzt
        then
          if l[x+1,y] < 16    // nicht markiert
          then untersuche(x+1,y);
        // oben
        if (l[x,y] and 4) = 0 // Bit2 nicht gesetzt
        then
          if l[x,y+1] < 16    // nicht markiert
          then untersuche(x,y+1);
        //links
        if (l[x,y] and 8) = 0   // Bit3 nicht gesetzt
        then
          if l[x-1,y] < 16      // nicht markiert
          then untersuche(x-1,y);
        // unten
        if (l[x,y] and 1) = 0   // Bit0 nicht gesetzt
        then
          if l[x,y-1] < 16      // nicht markiert
          then untersuche(x,y-1);
      end;
      l[x,y] := l[x,y]-16; // Markierung zurcknehmen, Bit4 lschen
      zeigeLabyrinth;
    end;
  end;

begin
  delay := StrToInt(eDelay.Text);
  untersuche(ax,ay);
end;

end.
